## zfp 1.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9)

# Enable MACOSX_RPATH by default
cmake_policy(SET CMP0042 NEW)

# Fail immediately if not using an out-of-source build
if(CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_CURRENT_BINARY_DIR)
  message(FATAL_ERROR
    "In-source builds are not supported.  Please create a build directory "
    "separate from the source directory")
endif()

#------------------------------------------------------------------------------#
# Parse version number from zfp.h
#------------------------------------------------------------------------------#
file(READ ${CMAKE_CURRENT_SOURCE_DIR}/include/zfp/version.h _zfp_h_contents)
string(REGEX REPLACE ".*#define[ \t]+ZFP_VERSION_MAJOR[ \t]+([0-9]+).*"
     "\\1" ZFP_VERSION_MAJOR ${_zfp_h_contents})
string(REGEX REPLACE ".*#define[ \t]+ZFP_VERSION_MINOR[ \t]+([0-9]+).*"
    "\\1" ZFP_VERSION_MINOR ${_zfp_h_contents})
string(REGEX REPLACE ".*#define[ \t]+ZFP_VERSION_PATCH[ \t]+([0-9]+).*"
    "\\1" ZFP_VERSION_PATCH ${_zfp_h_contents})
string(REGEX REPLACE ".*#define[ \t]+ZFP_VERSION_TWEAK[ \t]+([0-9]+).*"
    "\\1" ZFP_VERSION_TWEAK ${_zfp_h_contents})

if(${ZFP_VERSION_TWEAK} EQUAL 0)
  set(ZFP_VERSION
    "${ZFP_VERSION_MAJOR}.${ZFP_VERSION_MINOR}.${ZFP_VERSION_PATCH}")
else()
  set(ZFP_VERSION
    "${ZFP_VERSION_MAJOR}.${ZFP_VERSION_MINOR}.${ZFP_VERSION_PATCH}.${ZFP_VERSION_TWEAK}")
endif()

project(ZFP VERSION ${ZFP_VERSION})

#------------------------------------------------------------------------------#
# Some boilerplate to setup nice output directories
#------------------------------------------------------------------------------#
include(GNUInstallDirs)
set(CMAKE_INSTALL_CMAKEDIR ${CMAKE_INSTALL_LIBDIR}/cmake/zfp
  CACHE STRING "Installation CMake subdirectory")

list(INSERT CMAKE_MODULE_PATH 0 "${ZFP_SOURCE_DIR}/cmake")
if(NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${ZFP_BINARY_DIR}/${CMAKE_INSTALL_BINDIR})
endif()
if(NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${ZFP_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR})
endif()
if(NOT CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${ZFP_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR})
endif()

#------------------------------------------------------------------------------#
# Top level options
#------------------------------------------------------------------------------#

# Windows (Visual Studio) specific options
if(MSVC)
  # Use this to get a usable export library when building a DLL on Windows
  set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)

  # Silence extraneous Visual Studio specific warnings
  add_definitions(-D_CRT_SECURE_NO_WARNINGS -D_SCL_SECURE_NO_WARNINGS)
  add_compile_options(/wd4146)
  add_compile_options(/wd4305)
endif()

# Suggest C99
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 99)
endif()

if(MSVC OR MINGW)
  set(CMAKE_C_STANDARD 90)
endif()

message(STATUS "Compiling with C standard: ${CMAKE_C_STANDARD}")

# Suggest C++98
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 98)
endif()
message(STATUS "Compiling with C++ standard: ${CMAKE_CXX_STANDARD}")

include(CMakeDependentOption)

# Typically you'd always be able to enable shared libraries but default
# configurations with the Cray toolchain will explicitly disable shared lib
# support and only allow static libs.  Making this a cmake_dependent_option
# will ensure that shared library support will be disabled if the system does
# not support it.

# Setup shared library / -fPIC stuff
get_property(SHARED_LIBS_SUPPORTED GLOBAL PROPERTY TARGET_SUPPORTS_SHARED_LIBS)
cmake_dependent_option(BUILD_SHARED_LIBS
  "Whether or not to build shared libraries" ON
  "SHARED_LIBS_SUPPORTED" OFF)

# PIC is always on for shared libs.  This allows it to be selectable for
# static libs.
if(DEFINED ZFP_ENABLE_PIC)
  set(ZFP_ENABLE_PIC_DEFAULT ${ZFP_ENABLE_PIC})
elseif(DEFINED CMAKE_POSITION_INDEPENDENT_CODE)
  set(ZFP_ENABLE_PIC_DEFAULT ${CMAKE_POSITION_INDEPENDENT_CODE})
else()
  set(ZFP_ENABLE_PIC_DEFAULT ${SHARED_LIBS_SUPPORTED})
endif()
cmake_dependent_option(ZFP_ENABLE_PIC
  "Build with Position Independent Code" ${ZFP_ENABLE_PIC_DEFAULT}
  "SHARED_LIBS_SUPPORTED" OFF)
set(CMAKE_POSITION_INDEPENDENT_CODE ${ZFP_ENABLE_PIC})

# Compile-time options.

set(ZFP_BIT_STREAM_WORD_SIZE 64 CACHE STRING
  "Use smaller bit stream word type for finer rate granularity")
set_property(CACHE ZFP_BIT_STREAM_WORD_SIZE PROPERTY STRINGS "8;16;32;64")

if(CMAKE_C_COMPILER_ID MATCHES "PGI|NVHPC")
  # Use default alignment to address PGI compiler bug.
  set(ZFP_CACHE_LINE_SIZE 0 CACHE STRING "Cache line alignment in bytes")
  mark_as_advanced(ZFP_CACHE_LINE_SIZE)
endif()

set(PPM_CHROMA 2 CACHE STRING "Chroma block dimensionality for ppm example")
set_property(CACHE PPM_CHROMA PROPERTY STRINGS "1;2")

set(ZFP_ROUNDING_MODE ZFP_ROUND_NEVER CACHE STRING
  "Rounding mode for reducing bias")
set_property(CACHE ZFP_ROUNDING_MODE PROPERTY STRINGS "ZFP_ROUND_NEVER;ZFP_ROUND_FIRST;ZFP_ROUND_LAST")

option(ZFP_WITH_DAZ "Treat subnormals as zero to avoid overflow" OFF)

option(ZFP_WITH_CUDA "Enable CUDA parallel compression" OFF)

option(ZFP_WITH_BIT_STREAM_STRIDED "Enable strided access for progressive zfp streams" OFF)
mark_as_advanced(ZFP_WITH_BIT_STREAM_STRIDED)

option(ZFP_WITH_TIGHT_ERROR "Reduce slack in absolute errors" OFF)

option(ZFP_WITH_ALIGNED_ALLOC "Enable aligned memory allocation" OFF)
mark_as_advanced(ZFP_WITH_ALIGNED_ALLOC)

option(ZFP_WITH_CACHE_TWOWAY "Use two-way skew-associative cache" OFF)
mark_as_advanced(ZFP_WITH_CACHE_TWOWAY)

option(ZFP_WITH_CACHE_FAST_HASH
  "Use a faster but more collision prone hash function" OFF)
mark_as_advanced(ZFP_WITH_CACHE_FAST_HASH)

option(ZFP_WITH_CACHE_PROFILE "Count cache misses" OFF)
mark_as_advanced(ZFP_WITH_CACHE_PROFILE)

# Handle compile-time macros

if((DEFINED ZFP_INT64) AND (DEFINED ZFP_INT64_SUFFIX))
  list(APPEND zfp_public_defs ZFP_INT64=${ZFP_INT64})
  list(APPEND zfp_public_defs ZFP_INT64_SUFFIX=${ZFP_INT64_SUFFIX})
endif()

if((DEFINED ZFP_UINT64) AND (DEFINED ZFP_UINT64_SUFFIX))
  list(APPEND zfp_public_defs ZFP_UINT64=${ZFP_UINT64})
  list(APPEND zfp_public_defs ZFP_UINT64_SUFFIX=${ZFP_UINT64_SUFFIX})
endif()

# This odd cmake pattern here lets the OpenMP feature be either auto-detected,
# explicitly enabled, or explicitly disabled, instead of just on or off.
if(DEFINED ZFP_WITH_OPENMP)
  option(ZFP_WITH_OPENMP "Enable OpenMP parallel compression"
    ${ZFP_WITH_OPENMP})
  if(ZFP_WITH_OPENMP)
    if(BUILD_EXAMPLES)
      find_package(OpenMP COMPONENTS C CXX REQUIRED)
    else()
      find_package(OpenMP COMPONENTS C REQUIRED)
    endif()
  endif()
else()
  if(BUILD_EXAMPLES)
    find_package(OpenMP COMPONENTS C CXX)
  else()
    find_package(OpenMP COMPONENTS C)
  endif()
  option(ZFP_WITH_OPENMP "Enable OpenMP parallel compression" ${OPENMP_FOUND})
endif()

# Suppress CMake warning about unused variable in this file
set(TOUCH_UNUSED_VARIABLE ${ZFP_OMP_TESTS_ONLY})

# Some compilers don't use explicit libraries on the link line for OpenMP but
# instead need to treat the OpenMP C flags as both compile and link flags
# i.e. -fopenmp for compiling and -lgomp for linking, use -fomp for both
# compiling and linking
if(ZFP_WITH_OPENMP AND NOT OpenMP_C_LIBRARIES)
  set(OpenMP_C_LIBRARIES ${OpenMP_C_FLAGS})
endif()

if(ZFP_WITH_CUDA)
  # use CUDA_BIN_DIR hint
  set(ENV{CUDA_BIN_PATH} ${CUDA_BIN_DIR})
  find_package(CUDA)
  if(NOT CUDA_FOUND)
    message(FATAL_ERROR "ZFP_WITH_CUDA is enabled, but a CUDA installation was not found.")
  endif()
  if(${CUDA_VERSION_MAJOR} LESS 7)
    message(FATAL_ERROR "zfp requires at least CUDA 7.0.")
  endif()
endif()

if(NOT (ZFP_BIT_STREAM_WORD_SIZE EQUAL 64))
  list(APPEND zfp_private_defs BIT_STREAM_WORD_TYPE=uint${ZFP_BIT_STREAM_WORD_SIZE})
endif()

if(DEFINED ZFP_CACHE_LINE_SIZE)
  # Add to zfp_public_defs since many tests currently include files from src.
#  list(APPEND zfp_public_defs ZFP_CACHE_LINE_SIZE=${ZFP_CACHE_LINE_SIZE})
  list(APPEND zfp_private_defs ZFP_CACHE_LINE_SIZE=${ZFP_CACHE_LINE_SIZE})
endif()

if(ZFP_WITH_BIT_STREAM_STRIDED)
  list(APPEND zfp_public_defs BIT_STREAM_STRIDED)
endif()

if(NOT (ZFP_ROUNDING_MODE EQUAL ZFP_ROUND_NEVER))
  list(APPEND zfp_private_defs ZFP_ROUNDING_MODE=${ZFP_ROUNDING_MODE})
endif()

if(ZFP_WITH_TIGHT_ERROR)
  if((ZFP_ROUNDING_MODE EQUAL 0) OR (ZFP_ROUNDING_MODE STREQUAL ZFP_ROUND_NEVER))
    message(FATAL_ERROR "ZFP_WITH_TIGHT_ERROR requires ZFP_ROUND_FIRST or ZFP_ROUND_LAST rounding mode")
  endif()
  list(APPEND zfp_private_defs ZFP_WITH_TIGHT_ERROR)
endif()

if(ZFP_WITH_DAZ)
  list(APPEND zfp_private_defs ZFP_WITH_DAZ)
endif()

if(ZFP_WITH_ALIGNED_ALLOC)
  list(APPEND zfp_compressed_array_defs ZFP_WITH_ALIGNED_ALLOC)
endif()

if(ZFP_WITH_CACHE_TWOWAY)
  list(APPEND zfp_compressed_array_defs ZFP_WITH_CACHE_TWOWAY)
endif()

if(ZFP_WITH_CACHE_FAST_HASH)
  list(APPEND zfp_compressed_array_defs ZFP_WITH_CACHE_FAST_HASH)
endif()

if(ZFP_WITH_CACHE_PROFILE)
  list(APPEND zfp_compressed_array_defs ZFP_WITH_CACHE_PROFILE)
endif()

list(APPEND ppm_private_defs PPM_CHROMA=${PPM_CHROMA})

# Link libm only if necessary
include(CheckCSourceCompiles)
check_c_source_compiles("#include<math.h>\nfloat f; int main(){sqrt(f);return 0;}" HAVE_MATH)
if(NOT HAVE_MATH)
  set(CMAKE_REQUIRED_LIBRARIES m)
  check_c_source_compiles("#include<math.h>\nfloat f; int main(){sqrt(f);return 0;}" HAVE_LIBM_MATH)
  unset(CMAKE_REQUIRED_LIBRARIES)
  if(NOT HAVE_LIBM_MATH)
    message(FATAL_ERROR "Unable to use C math library functions (with or without -lm)")
  endif()
endif()

#------------------------------------------------------------------------------#
# Add source code
#------------------------------------------------------------------------------#
include(CTest)
if(BUILD_TESTING)
  enable_testing()
endif()

set(ZFP_LIBRARY_PREFIX "" CACHE STRING
  "Prefix to prepend to the output library name")
mark_as_advanced(ZFP_LIBRARY_PREFIX)

add_subdirectory(src)

option(BUILD_ALL "Build all subdirectories" OFF)
if(BUILD_ALL)
  set(BUILD_CFP ON CACHE BOOL "Build CFP arrays library" FORCE)
  set(BUILD_ZFORP ON CACHE BOOL "Build Fortran library" FORCE)
  set(BUILD_ZFPY ON CACHE BOOL "Build python bindings for zfp" FORCE)
  set(BUILD_UTILITIES ON CACHE BOOL "Build command line utilities for zfp" FORCE)
  set(BUILD_EXAMPLES ON CACHE BOOL "Build Examples" FORCE)
endif()

option(BUILD_CFP "Build CFP arrays library" OFF)
if(BUILD_CFP)
  add_subdirectory(cfp)
endif()

option(BUILD_ZFORP "Build Fortran library" OFF)
if(BUILD_ZFORP)
  add_subdirectory(fortran)
endif()

option(BUILD_ZFPY "Build python bindings for zfp" OFF)
if(BUILD_ZFPY)
  add_subdirectory(python)
endif()

option(BUILD_UTILITIES "Build command line utilities for zfp" ON)
if(BUILD_UTILITIES)
  add_subdirectory(utils)
endif()

option(BUILD_EXAMPLES "Build Examples" OFF)
if(BUILD_EXAMPLES)
  add_subdirectory(examples)
endif()

if(BUILD_TESTING)
  # Disable gtest install to prevent clobbering existing installations 
  option(INSTALL_GMOCK "Install Googlemock" OFF)
  option(INSTALL_GTEST "Install Googletest" OFF)

  add_subdirectory(tests)
endif()

#------------------------------------------------------------------------------#
# Header install
#------------------------------------------------------------------------------#
if(BUILD_CFP)
  install(DIRECTORY include/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
else()
  install(DIRECTORY include/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
          PATTERN "cfp" EXCLUDE)
endif()
#------------------------------------------------------------------------------#
# Build type: one of None, Debug, Release, RelWithDebInfo, MinSizeRel
#------------------------------------------------------------------------------#
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY VALUE Release)
endif()

#------------------------------------------------------------------------------#
# Packaging

=== cfp/Makefile ===
include ../Config

LIBDIR = ../lib
TARGETS = $(LIBDIR)/libcfp.a $(LIBDIR)/libcfp.so
OBJECTS = cfp.o
INCS = -I../include -I../src

static: $(LIBDIR)/libcfp.a

shared: $(LIBDIR)/libcfp.so

clean:
	rm -f $(TARGETS) $(OBJECTS)

$(LIBDIR)/libcfp.a: $(OBJECTS)
	mkdir -p $(LIBDIR)
	rm -f $@
	ar rc $@ $^

$(LIBDIR)/libcfp.so: $(OBJECTS)
	mkdir -p $(LIBDIR)
	$(CXX) $(CXXFLAGS) -shared $(SOFLAGS) $^ -o $@

.cpp.o:
	$(CXX) $(CXXFLAGS) $(INCS) -c $<

=== fortran/CMakeLists.txt ===
enable_language(Fortran)

if(CMAKE_Fortran_COMPILER_ID MATCHES "GNU")
  set(dialect "-ffree-form -fimplicit-none")
  set(bounds "-fbounds-check")
endif()
if(CMAKE_Fortran_COMPILER_ID MATCHES "Intel")
  set(dialect "-stand -free -implicitnone")
  set(bounds "-check bounds")
endif()

set(CMAKE_Fortran_MODULE_DIRECTORY ${CMAKE_BINARY_DIR}/modules)
set(CMAKE_Fortran_FLAGS_DEBUG "${CMAKE_Fortran_FLAGS_DEBUG} ${bounds}")
set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} ${dialect}")

add_library(zFORp zfp.f90)
target_link_libraries(zFORp PRIVATE zfp)

set_property(TARGET zFORp PROPERTY VERSION ${ZFP_VERSION})
set_property(TARGET zFORp PROPERTY SOVERSION ${ZFP_VERSION_MAJOR})
set_property(TARGET zFORp PROPERTY OUTPUT_NAME ${ZFP_LIBRARY_PREFIX}zFORp)

# install location for module file
install(FILES ${CMAKE_Fortran_MODULE_DIRECTORY}/zfp.mod
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

# install location for library
install(TARGETS zFORp EXPORT cFORp-targets
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== python/CMakeLists.txt ===
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_LIST_DIR}/scikit-build-cmake)
include(UseCython)
include(FindPythonExtensions)
include(FindNumPy)

find_package(PythonInterp REQUIRED)
find_package(PythonLibs REQUIRED)
find_package(PythonExtensions REQUIRED)
find_package(Cython REQUIRED)
find_package(NumPy REQUIRED)

include_directories(${ZFP_SOURCE_DIR}/include)
include_directories(${NumPy_INCLUDE_DIR})

add_cython_target(zfpy zfpy.pyx C)
add_library(zfpy MODULE ${zfpy})
target_link_libraries(zfpy zfp)
python_extension_module(zfpy)

# Build to the current binary dir to avoid conflicts with other libraries named zfp
set(PYLIB_BUILD_DIR "${CMAKE_BINARY_DIR}/bin" CACHE PATH "Directory where zfp python library will be built")
set_target_properties(zfpy PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${PYLIB_BUILD_DIR})

# Install to the typical python module directory
set(python_install_lib_dir "lib/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/site-packages/")
install(TARGETS zfpy LIBRARY DESTINATION ${python_install_lib_dir})

=== python/requirements.txt ===
cython>=0.22
numpy>=1.8.0

=== src/CMakeLists.txt ===
if(ZFP_WITH_CUDA)
  set(CMAKE_CXX_FLAGS_PREVIOUS ${CMAKE_CXX_FLAGS})
  set(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -fPIC" )

  add_subdirectory(cuda_zfp)
  cuda_include_directories(${PROJECT_SOURCE_DIR}/include)
  cuda_wrap_srcs(zfp OBJ zfp_cuda_backend_obj cuda_zfp/cuZFP.cu OPTIONS ${CMAKE_CUDA_FLAGS})
  set(CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS_PREVIOUS})
  add_definitions(-DZFP_WITH_CUDA)
endif()


set(zfp_source
  zfp.c
  bitstream.c
  traitsf.h traitsd.h block1.h block2.h block3.h block4.h
  encode1f.c encode1d.c encode1i.c encode1l.c
  decode1f.c decode1d.c decode1i.c decode1l.c
  encode2f.c encode2d.c encode2i.c encode2l.c
  decode2f.c decode2d.c decode2i.c decode2l.c
  encode3f.c encode3d.c encode3i.c encode3l.c
  decode3f.c decode3d.c decode3i.c decode3l.c
  encode4f.c encode4d.c encode4i.c encode4l.c
  decode4f.c decode4d.c decode4i.c decode4l.c)

add_library(zfp ${zfp_source}
                ${zfp_cuda_backend_obj})
add_library(zfp::zfp ALIAS zfp)

if(ZFP_WITH_OPENMP)
  target_link_libraries(zfp PRIVATE OpenMP::OpenMP_C)
endif()

if(HAVE_LIBM_MATH)
  target_link_libraries(zfp PRIVATE m)
endif()

if(WIN32 AND BUILD_SHARED_LIBS)
  # Define ZFP_SOURCE when compiling libzfp to export symbols to Windows DLL
  list(APPEND zfp_public_defs ZFP_SHARED_LIBS)
  list(APPEND zfp_private_defs ZFP_SOURCE)
endif()

if(ZFP_WITH_CUDA)
  target_link_libraries(zfp PRIVATE ${CUDA_CUDART_LIBRARY} stdc++)
endif()

target_compile_definitions(zfp
  PRIVATE ${zfp_private_defs}
  PUBLIC ${zfp_public_defs}
)

target_include_directories(zfp
  PUBLIC
    $<BUILD_INTERFACE:${ZFP_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

set_property(TARGET zfp PROPERTY VERSION ${ZFP_VERSION})
set_property(TARGET zfp PROPERTY SOVERSION ${ZFP_VERSION_MAJOR})
set_property(TARGET zfp PROPERTY OUTPUT_NAME ${ZFP_LIBRARY_PREFIX}zfp)

install(TARGETS zfp EXPORT zfp-targets
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== src/Makefile ===
include ../Config

LIBDIR = ../lib
TARGETS = $(LIBDIR)/libzfp.a $(LIBDIR)/libzfp.so
OBJECTS = bitstream.o decode1i.o decode1l.o decode1f.o decode1d.o encode1i.o encode1l.o encode1f.o encode1d.o decode2i.o decode2l.o decode2f.o decode2d.o encode2i.o encode2l.o encode2f.o encode2d.o decode3i.o decode3l.o decode3f.o decode3d.o encode3i.o encode3l.o encode3f.o encode3d.o decode4i.o decode4l.o decode4f.o decode4d.o encode4i.o encode4l.o encode4f.o encode4d.o zfp.o

static: $(LIBDIR)/libzfp.a

shared: $(LIBDIR)/libzfp.so

clean:
	rm -f $(TARGETS) $(OBJECTS)

$(LIBDIR)/libzfp.a: $(OBJECTS)
	mkdir -p $(LIBDIR)
	rm -f $@
	ar rc $@ $^

$(LIBDIR)/libzfp.so: $(OBJECTS)
	mkdir -p $(LIBDIR)
	$(CC) $(CFLAGS) -shared $^ -o $@

.c.o:
	$(CC) $(CFLAGS) -I../include -c $<

=== tests/CMakeLists.txt ===
add_executable(testzfp testzfp.cpp)
target_link_libraries(testzfp zfp)
target_compile_definitions(testzfp PRIVATE ${zfp_compressed_array_defs})

option(ZFP_BUILD_TESTING_SMALL "Enable small-sized array testing" ON)
if(ZFP_BUILD_TESTING_SMALL)
  foreach(D IN ITEMS 1 2 3 4)
    foreach(P IN ITEMS 32 64)
      add_test(NAME small-arrays-${D}d-fp${P} COMMAND testzfp small ${D}d fp${P})
    endforeach()
  endforeach()
endif()

option(ZFP_BUILD_TESTING_LARGE "Enable large-sized array testing" OFF)
if(ZFP_BUILD_TESTING_LARGE)
  foreach(D IN ITEMS 1 2 3 4)
    foreach(P IN ITEMS 32 64)
      add_test(NAME large-arrays-${D}d-fp${P} COMMAND testzfp large ${D}d fp${P})
    endforeach()
  endforeach()
endif()

=== tests/Makefile ===
include ../Config

BINDIR = ../bin
TARGETS = $(BINDIR)/testzfp
INCS = -I../include
LIBS = -L../lib -lzfp $(LDFLAGS)

all: $(TARGETS)

$(BINDIR)/testzfp: testzfp.cpp ../lib/$(LIBZFP)
	$(CXX) $(CXXFLAGS) $(INCS) testzfp.cpp $(LIBS) -o $@

test: $(BINDIR)/testzfp
	$(BINDIR)/testzfp

clean:
	rm -f $(TARGETS)

=== utils/CMakeLists.txt ===
add_executable(zfpcmd zfp.c)

# protect against LNK1114: cannot overwrite the original file 'lib/Release/zfp.lib'; error code 32;
# rationale: linker can't handle the case of an executable file having the same name as a library file
if(NOT MSVC)
  set_property(TARGET zfpcmd PROPERTY OUTPUT_NAME zfp)
endif()
target_link_libraries(zfpcmd zfp)
if(HAVE_LIBM_MATH)
  target_link_libraries(zfpcmd m)
endif()

if(BUILD_UTILITIES)
  install(TARGETS zfpcmd
    DESTINATION "${CMAKE_INSTALL_BINDIR}")
endif()

=== debian/changelog ===
zfp (1.0.0-7) unstable; urgency=medium

  * Standards version bumped to 4.6.2, no changes.
  * debian/patches:
    - new 0001-Prevent-LTO-in-libm-dependency-check.patch.
      Closes: #1030107.
  * Enable LTO optimization.
  * Update d/copyright.

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Sat, 11 Feb 2023 08:49:53 +0000

zfp (1.0.0-6) unstable; urgency=medium

  * Apply patch. Thanks Graham Inggs. (Closes: #1030109)

 -- Gürkan Myczko <tar@debian.org>  Tue, 31 Jan 2023 13:44:11 +0100

zfp (1.0.0-5) unstable; urgency=medium

  * Team upload.
  * Use pybuild to compile for all Python versions (Closes: #1025196)
  * Use dh-sequences
  * Move package description to source package
  * Cleanup install files

 -- Jochen Sprickerhof <jspricke@debian.org>  Fri, 02 Dec 2022 10:19:38 +0100

zfp (1.0.0-4) unstable; urgency=medium

  * Team upload acked by Gürkan Myczko.

  [ Debian Janitor ]
  * Apply multi-arch hints. + libzfp-dev: Drop Multi-Arch: same.

  [ Helmut Grohne ]
  * Don't move cmake files around. (Closes: #1025259)

 -- Helmut Grohne <helmut@subdivi.de>  Fri, 02 Dec 2022 09:38:28 +0100

zfp (1.0.0-3) unstable; urgency=medium

  * Compile with -DZFP_BIT_STREAM_WORD_SIZE=8. (Closes: #1023821)

 -- Gürkan Myczko <tar@debian.org>  Thu, 10 Nov 2022 22:27:10 +0100

zfp (1.0.0-2) unstable; urgency=medium

  * Upload to sid.
  * d/rules: set ZFP_BUILD_TESTING_SMALL to OFF.

 -- Gürkan Myczko <tar@debian.org>  Fri, 16 Sep 2022 08:28:04 +0200

zfp (1.0.0-1) experimental; urgency=medium

  * Initial release. (Closes: #1017808)

 -- Gürkan Myczko <tar@debian.org>  Sat, 20 Aug 2022 21:51:21 +0200

=== debian/control ===
Source: zfp
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Gürkan Myczko <tar@debian.org>,
           Antonio Valentino <antonio.valentino@tiscali.it>
Rules-Requires-Root: no
Testsuite: autopkgtest-pkg-python
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 cython3,
 gfortran,
 dh-sequence-python3,
 dh-sequence-numpy3,
 libpython3-all-dev,
 dh-sequence-pkgkde-symbolshelper,
 python3-numpy,
 python3-setuptools,
 python3-all
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/science-team/zfp
Vcs-Git: https://salsa.debian.org/science-team/zfp.git
Homepage: https://zfp.llnl.gov
Description: Fixed-Rate Compressed Floating-Point Arrays
 This is a compressed format for representing multidimensional floating-point
 and integer arrays.  zfp provides compressed-array classes that support high
 throughput read and write random access to individual array elements. zfp
 also supports serial and parallel (OpenMP and CUDA) compression of whole
 arrays, e.g., for applications that read and write large data sets to and
 from disk.

Package: libzfp1
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: ${source:Synopsis}
 ${source:Extended-Description}

Package: libzfp-dev
Architecture: any
Section: libdevel
Depends:
 ${misc:Depends},
 libzfp1 (= ${binary:Version}),
Description: ${source:Synopsis} (Development files)
 ${source:Extended-Description}
 .
 This is a development package of zfp.

Package: zfp
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: ${source:Synopsis} - binary programs
 ${source:Extended-Description}
 .
 This package contains the binary program zfp.

Package: python3-zfpy
Architecture: any
Section: python
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
 libzfp1,
 python3-numpy
Description: Python 3 bindings to the ${source:Synopsis}
 ${source:Extended-Description}
 .
 This is a Python package of zfp.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

include /usr/share/dpkg/pkg-info.mk
UPSTREAM_VERSION = $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/\+.*//')

# See FEATURE AREAS in dpkg-buildflags(1).
export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=+lto

# See ENVIRONMENT in dpkg-buildflags(1).
# Package maintainers to append CFLAGS.
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# Package maintainers to append LDFLAGS.
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export PYBUILD_CONFIGURE_ARGS=-DBUILD_ZFORP=ON -DBUILD_ZFPY=ON -DZFP_BUILD_TESTING_SMALL=OFF -DZFP_BIT_STREAM_WORD_SIZE=8
export PYBUILD_SYSTEM=cmake

%:
	dh $@ --buildsystem=pybuild

override_dh_dwz:
	@echo "BYE DWZ"

override_dh_makeshlibs:
	dh_makeshlibs -- -v$(UPSTREAM_VERSION) -c0

## zfp 1.0.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -50,6 +50,9 @@
 if(NOT CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
   set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${ZFP_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR})
 endif()
+
+# Setup RPath
+set(CMAKE_INSTALL_RPATH ${CMAKE_INSTALL_FULL_LIBDIR})
 
 #------------------------------------------------------------------------------#
 # Top level options
@@ -257,10 +260,10 @@
 
 # Link libm only if necessary
 include(CheckCSourceCompiles)
-check_c_source_compiles("#include<math.h>\nfloat f; int main(){sqrt(f);return 0;}" HAVE_MATH)
+check_c_source_compiles("#include<math.h>\nint main(int n,char*v[]){return sqrt(n);}" HAVE_MATH)
 if(NOT HAVE_MATH)
   set(CMAKE_REQUIRED_LIBRARIES m)
-  check_c_source_compiles("#include<math.h>\nfloat f; int main(){sqrt(f);return 0;}" HAVE_LIBM_MATH)
+  check_c_source_compiles("#include<math.h>\nint main(int n,char*v[]){return sqrt(n);}" HAVE_LIBM_MATH)
   unset(CMAKE_REQUIRED_LIBRARIES)
   if(NOT HAVE_LIBM_MATH)
     message(FATAL_ERROR "Unable to use C math library functions (with or without -lm)")
@@ -271,7 +274,7 @@
 # Add source code
 #------------------------------------------------------------------------------#
 include(CTest)
-if(BUILD_TESTING)
+if(BUILD_TESTING OR BUILD_TESTING_FULL)
   enable_testing()
 endif()
 
@@ -315,7 +318,7 @@
   add_subdirectory(examples)
 endif()
 
-if(BUILD_TESTING)
+if(BUILD_TESTING OR BUILD_TESTING_FULL)
   # Disable gtest install to prevent clobbering existing installations 
   option(INSTALL_GMOCK "Install Googlemock" OFF)
   option(INSTALL_GTEST "Install Googletest" OFF)
@@ -339,5 +342,3 @@
   set_property(CACHE CMAKE_BUILD_TYPE PROPERTY VALUE Release)
 endif()
 
-#------------------------------------------------------------------------------#
-# Packaging

=== Makefile ===
# see Config file for compile-time settings
include Config

MAKEFLAGS += --no-print-directory


# default: build all targets enabled in Config
all:
	@echo $(LIBRARY)
	@cd src; $(MAKE) clean $(LIBRARY)
ifneq ($(BUILD_CFP),0)
	@cd cfp; $(MAKE) clean $(LIBRARY)
endif
ifneq ($(BUILD_ZFORP),0)
	@cd fortran; $(MAKE) clean $(LIBRARY)
endif
ifneq ($(BUILD_UTILITIES),0)
	@cd utils; $(MAKE) clean all
endif
ifneq ($(BUILD_TESTING),0)
	@cd tests; $(MAKE) clean all
endif
ifneq ($(BUILD_EXAMPLES),0)
	@cd examples; $(MAKE) clean all
endif


# run basic regression tests
test:
	@cd tests; $(MAKE) test


# clean all
clean:
	@cd src; $(MAKE) clean
	@cd cfp; $(MAKE) clean
	@cd fortran; $(MAKE) clean
	@cd utils; $(MAKE) clean
	@cd tests; $(MAKE) clean
	@cd examples; $(MAKE) clean

=== cfp/CMakeLists.txt ===
add_library(cfp cfp.cpp)

if(DEFINED CFP_NAMESPACE)
  list(APPEND cfp_public_defs "CFP_NAMESPACE=${CFP_NAMESPACE}")
endif()

list(APPEND cfp_private_defs ${zfp_compressed_array_defs})

if(WIN32 AND BUILD_SHARED_LIBS)
  # define ZFP_SOURCE when compiling libcfp to export symbols to Windows DLL
  list(APPEND cfp_public_defs ZFP_SHARED_LIBS)
  list(APPEND cfp_private_defs ZFP_SOURCE)
endif()

target_compile_definitions(cfp
  PUBLIC ${cfp_public_defs}
  PRIVATE ${cfp_private_defs})

target_include_directories(cfp
  PUBLIC
    $<BUILD_INTERFACE:${ZFP_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
  PRIVATE
    ${ZFP_SOURCE_DIR}/src
)

target_link_libraries(cfp zfp)

set_property(TARGET cfp PROPERTY VERSION ${ZFP_VERSION})
set_property(TARGET cfp PROPERTY SOVERSION ${ZFP_VERSION_MAJOR})
set_property(TARGET cfp PROPERTY OUTPUT_NAME ${ZFP_LIBRARY_PREFIX}cfp)

install(TARGETS cfp EXPORT cfp-targets
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== docs/requirements.txt ===
sphinx-fortran==1.1.1

# required by sphinx-fortran but not installed on RTD
six

=== examples/CMakeLists.txt ===
add_executable(array array.cpp)
target_compile_definitions(array PRIVATE ${zfp_compressed_array_defs})
target_link_libraries(array zfp)

add_executable(diffusion diffusion.cpp)
target_compile_definitions(diffusion PRIVATE ${zfp_compressed_array_defs})
if(ZFP_WITH_OPENMP)
  target_link_libraries(diffusion zfp OpenMP::OpenMP_CXX)
else()
  target_link_libraries(diffusion zfp)
endif()

if(BUILD_CFP)
  add_executable(diffusionC diffusionC.c)
  target_link_libraries(diffusionC cfp)
endif()

add_executable(inplace inplace.c)
target_link_libraries(inplace zfp)

add_executable(iterator iterator.cpp)
target_link_libraries(iterator zfp)
target_compile_definitions(iterator PRIVATE ${zfp_compressed_array_defs})

if(BUILD_CFP)
  add_executable(iteratorC iteratorC.c)
  target_link_libraries(iteratorC cfp)
endif()

add_executable(pgm pgm.c)
target_link_libraries(pgm zfp)

add_executable(ppm ppm.c)
target_link_libraries(ppm zfp)
target_compile_definitions(ppm PRIVATE ${ppm_private_defs})

add_executable(simple simple.c)
target_link_libraries(simple zfp)

add_executable(speed speed.c)
target_link_libraries(speed zfp)

if(HAVE_LIBM_MATH)
  target_link_libraries(array m)
  target_link_libraries(diffusion m)

  if(BUILD_CFP)
    target_link_libraries(diffusionC m)
  endif()

  target_link_libraries(inplace m)
  target_link_libraries(pgm m)
  target_link_libraries(ppm m)
  target_link_libraries(simple m)
endif()

=== examples/Makefile ===
include ../Config

BINDIR = ../bin
TARGETS = $(BINDIR)/array\
	  $(BINDIR)/diffusion\
	  $(BINDIR)/inplace\
	  $(BINDIR)/iterator\
	  $(BINDIR)/pgm\
	  $(BINDIR)/ppm\
	  $(BINDIR)/simple\
	  $(BINDIR)/speed
INCS = -I../include
LIBS = -L../lib -lzfp
CLIBS = $(LIBS) $(LDFLAGS) -lm
CXXLIBS = $(LIBS) $(LDFLAGS)

# add cfp examples when BUILD_CFP is enabled
ifneq ($(BUILD_CFP),0)
  TARGETS += $(BINDIR)/diffusionC $(BINDIR)/iteratorC
endif


all: $(TARGETS)

$(BINDIR)/array: array.cpp ../lib/$(LIBZFP)
	$(CXX) $(CXXFLAGS) $(INCS) array.cpp $(CXXLIBS) -o $@

$(BINDIR)/diffusion: diffusion.cpp ../lib/$(LIBZFP)
	$(CXX) $(CXXFLAGS) $(INCS) diffusion.cpp $(CXXLIBS) -o $@

$(BINDIR)/diffusionC: diffusionC.o ../lib/$(LIBZFP) ../lib/$(LIBCFP)
	$(CXX) $(CXXFLAGS) diffusionC.o -lcfp $(CLIBS) -o $@

diffusionC.o: diffusionC.c
	$(CC) $(CFLAGS) $(INCS) -c diffusionC.c

$(BINDIR)/inplace: inplace.c ../lib/$(LIBZFP)
	$(CC) $(CFLAGS) $(INCS) inplace.c $(CLIBS) -o $@

$(BINDIR)/iterator: iterator.cpp ../lib/$(LIBZFP)
	$(CXX) $(CXXFLAGS) $(INCS) iterator.cpp $(CXXLIBS) -o $@

$(BINDIR)/iteratorC: iteratorC.o ../lib/$(LIBZFP) ../lib/$(LIBCFP)
	$(CXX) $(CXXFLAGS) iteratorC.o -lcfp $(CLIBS) -o $@

iteratorC.o: iteratorC.c
	$(CC) $(CFLAGS) $(INCS) -c iteratorC.c

$(BINDIR)/pgm: pgm.c ../lib/$(LIBZFP)
	$(CC) $(CFLAGS) $(INCS) pgm.c $(CLIBS) -o $@

$(BINDIR)/ppm: ppm.c ../lib/$(LIBZFP)
	$(CC) $(CFLAGS) $(PPM_FLAGS) $(INCS) ppm.c $(CLIBS) -o $@

$(BINDIR)/simple: simple.c ../lib/$(LIBZFP)
	$(CC) $(CFLAGS) $(INCS) simple.c $(CLIBS) -o $@

$(BINDIR)/speed: speed.c ../lib/$(LIBZFP)
	$(CC) $(CFLAGS) $(INCS) speed.c $(CLIBS) -o $@

clean:
	rm -f $(TARGETS) $(BINDIR)/diffusionC $(BINDIR)/iteratorC diffusionC.o iteratorC.o

=== fortran/Makefile ===
include ../Config

.SUFFIXES: .f90

LIBDIR = ../lib
MODDIR = ../modules
TARGETS = $(LIBDIR)/libzFORp.a $(LIBDIR)/libzFORp.so $(MODDIR)/zfp.mod
OBJECTS = zfp.o
MODULES = zfp.mod

static: $(LIBDIR)/libzFORp.a $(MODDIR)/zforp.mod

shared: $(LIBDIR)/libzFORp.so $(MODDIR)/zforp.mod

clean:
	rm -f $(TARGETS) $(OBJECTS)

$(LIBDIR)/libzFORp.a: $(OBJECTS)
	mkdir -p $(LIBDIR)
	rm -f $@
	ar rc $@ $^

$(LIBDIR)/libzFORp.so: $(OBJECTS)
	mkdir -p $(LIBDIR)
	$(FC) $(FFLAGS) -shared $^ -o $@

$(MODDIR)/zforp.mod: $(OBJECTS)
	mkdir -p $(MODDIR)
	mv $(MODULES) $(MODDIR)

.f90.o:
	$(FC) $(FFLAGS) -c $<

=== python/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,7 @@
+if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.27.0)
+    cmake_policy(SET CMP0148 OLD)
+endif ()
+
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_LIST_DIR}/scikit-build-cmake)
 include(UseCython)
 include(FindPythonExtensions)
@@ -6,13 +10,13 @@
 find_package(PythonInterp REQUIRED)
 find_package(PythonLibs REQUIRED)
 find_package(PythonExtensions REQUIRED)
-find_package(Cython REQUIRED)
+find_package(Cython 0.28 REQUIRED) # >= v0.28 required for const memoryview support
 find_package(NumPy REQUIRED)
 
 include_directories(${ZFP_SOURCE_DIR}/include)
 include_directories(${NumPy_INCLUDE_DIR})
 
-add_cython_target(zfpy zfpy.pyx C)
+add_cython_target(zfpy zfpy.pyx C PY3)
 add_library(zfpy MODULE ${zfpy})
 target_link_libraries(zfpy zfp)
 python_extension_module(zfpy)

=== python/requirements.txt ===
cython>=0.22
numpy>=1.8.0

=== tests/CMakeLists.txt ===
if(BUILD_TESTING OR BUILD_TESTING_FULL)
  # testzfp
  add_executable(testzfp testzfp.cpp)
  target_link_libraries(testzfp zfp)
  target_compile_definitions(testzfp PRIVATE ${zfp_compressed_array_defs})
  add_test(NAME testzfp COMMAND testzfp)
  
  # testviews
  add_executable(testviews testviews.cpp)
  if(ZFP_WITH_OPENMP)
    target_link_libraries(testviews zfp OpenMP::OpenMP_C)
  else()
    target_link_libraries(testviews zfp)
  endif()
  target_compile_definitions(testviews PRIVATE ${zfp_compressed_array_defs})
  add_test(NAME testviews COMMAND testviews)
endif()

if(BUILD_TESTING_FULL)
  set(CMAKE_CXX_STANDARD 11)
  
  # CMAKE_SH-NOTFOUND needed for mingw builds
  if(MINGW)
    list(APPEND CMOCKA_ARGS "-DCMAKE_SH=CMAKE_SH-NOTFOUND")
    list(APPEND GTEST_ARGS "-DCMAKE_SH=CMAKE_SH-NOTFOUND")
  endif()
  
  # clone cmocka 1.1.0 into /build
  list(APPEND CMOCKA_ARGS "-DWITH_STATIC_LIB=ON;-DCMAKE_C_COMPILER=${CMAKE_C_COMPILER};-DUNIT_TESTING=OFF")
  
  include(ExternalProject)
  ExternalProject_Add(
    cmocka_cloned
    GIT_REPOSITORY    https://gitlab.com/cmocka/cmocka.git
    GIT_TAG           cmocka-1.1.5
    SOURCE_DIR        "${CMAKE_BINARY_DIR}/cmocka-src"
    BINARY_DIR        "${CMAKE_BINARY_DIR}/cmocka-build"
    CMAKE_ARGS        "${CMOCKA_ARGS}"
    INSTALL_COMMAND   ""
    STEP_TARGETS build
    EXCLUDE_FROM_ALL TRUE
  )
  ExternalProject_Get_Property(cmocka_cloned source_dir binary_dir)
  
  # name static library cmocka, wire up against cmocka_cloned
  add_library(cmocka STATIC IMPORTED GLOBAL)
  
  # choose proper library path & extension
  if(MSVC)
    set(IMPORTED_LOCATION_PATH "${binary_dir}/src/${CMAKE_BUILD_TYPE}/cmocka-static.lib")
  else()
    set(IMPORTED_LOCATION_PATH "${binary_dir}/src/libcmocka-static.a")
  endif()
  set_property(TARGET cmocka
    PROPERTY
    IMPORTED_LOCATION "${IMPORTED_LOCATION_PATH}"
  )
  
  add_dependencies(cmocka cmocka_cloned)
  include_directories(${source_dir}/include)
  
  # include home dir so #include statements are clear in test files
  include_directories(${ZFP_SOURCE_DIR} ${ZFP_SOURCE_DIR}/include)
  # access to constants/ and utils/
  include_directories(${CMAKE_CURRENT_SOURCE_DIR})
  
  # suppress warnings for all targets
  if(CMAKE_C_COMPILER_ID STREQUAL "GNU" OR CMAKE_C_COMPILER_ID STREQUAL "Clang")
    add_compile_options(-Wno-unused-function)
  endif()
  # -Wno-variadic-macros was not working for gcc...revisit
  if(CMAKE_C_COMPILER_ID STREQUAL "Clang")
    add_compile_options(-Wno-gnu-zero-variadic-macro-arguments)
  endif()
  # suppress googletest warning "conversion from 'float' to 'testing::internal::BiggestInt', possible loss of data"
  if(MSVC)
    add_compile_options(/wd4244)
  endif()
  
  
  add_subdirectory(utils)
  add_subdirectory(src)
  
  if(BUILD_CFP)
    add_subdirectory(cfp)
  endif()
  
  if(BUILD_ZFORP)
    add_subdirectory(fortran)
  endif()
  
  # needed to compile gtest on MSVC
  if(MSVC)
    list(APPEND GTEST_ARGS "/D:_SILENCE_TR1_DEPRECATION_NAMESPACE_WARNING=1")
  endif()
  
  # TODO: spend time getting googletest to compile on MinGW
  # checksums are generated through C tests, no need to compile C++ tests
  if((NOT MINGW) AND (NOT DEFINED ZFP_OMP_TESTS_ONLY) AND (NOT PRINT_CHECKSUMS))
    # clone googletest into build/
    configure_file(CMakeLists.txt.in ${ZFP_BINARY_DIR}/tests/googletest-download/CMakeLists.txt)
    execute_process(COMMAND ${CMAKE_COMMAND} -G "${CMAKE_GENERATOR}" ${GTEST_ARGS} .
      RESULT_VARIABLE result
      WORKING_DIRECTORY ${ZFP_BINARY_DIR}/tests/googletest-download
    )
  
    if(result)
      message(FATAL_ERROR "CMake step for googletest failed: ${result}")
    endif()
    # build gtest
    execute_process(COMMAND ${CMAKE_COMMAND} --build .
      RESULT_VARIABLE result
      WORKING_DIRECTORY ${ZFP_BINARY_DIR}/tests/googletest-download
    )
    if(result)
      message(FATAL_ERROR "Build step for googletest failed: ${result}")
    endif()
  
    set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
  
    add_subdirectory(${ZFP_BINARY_DIR}/tests/googletest-src
      ${ZFP_BINARY_DIR}/tests/googletest-build
    )
  
    if(CMAKE_VERSION VERSION_LESS 2.8.11)
      include_directories("${gtest_SOURCE_DIR}/include")
    endif()
  
    # needed to compile zfp tests with gtest on MSVC
    if(MSVC)
      target_compile_definitions(gtest_main INTERFACE GTEST_LINKED_AS_SHARED_LIBRARY=1)
    endif()
  
    add_subdirectory(array)
  endif()
  
  option(ZFP_BUILD_TESTING_SMALL "Enable small-sized array testing" ON)
  if(ZFP_BUILD_TESTING_SMALL)
    foreach(D IN ITEMS 1 2 3 4)
      foreach(P IN ITEMS 32 64)
        add_test(NAME small-arrays-${D}d-fp${P} COMMAND testzfp small ${D}d fp${P})
      endforeach()
    endforeach()
  endif()
  
  option(ZFP_BUILD_TESTING_LARGE "Enable large-sized array testing" OFF)
  if(ZFP_BUILD_TESTING_LARGE)
    foreach(D IN ITEMS 1 2 3 4)
      foreach(P IN ITEMS 32 64)
        add_test(NAME large-arrays-${D}d-fp${P} COMMAND testzfp large ${D}d fp${P})
      endforeach()
    endforeach()
  endif()
  
  if(BUILD_ZFPY)
    add_subdirectory(python)
  endif()
endif()

=== tests/Makefile ===
include ../Config

BINDIR = ../bin
TARGETS = $(BINDIR)/testzfp $(BINDIR)/testviews
INCS = -I../include
LIBS = -L../lib -lzfp $(LDFLAGS)

all: $(TARGETS)

$(BINDIR)/testzfp: testzfp.cpp ../lib/$(LIBZFP)
	$(CXX) $(CXXFLAGS) $(INCS) testzfp.cpp $(LIBS) -o $@

$(BINDIR)/testviews: testviews.cpp ../lib/$(LIBZFP)
	$(CXX) $(CXXFLAGS) $(INCS) testviews.cpp $(LIBS) -o $@

test: $(BINDIR)/testzfp
	$(BINDIR)/testzfp

clean:
	rm -f $(TARGETS)

=== utils/Makefile ===
include ../Config

TARGET = ../bin/zfp
INCS = -I../include
LIBS = -L../lib -lzfp $(LDFLAGS) -lm

all: $(TARGET)

$(TARGET): zfp.c ../lib/$(LIBZFP)
	mkdir -p ../bin
	$(CC) $(CFLAGS) $(INCS) zfp.c $(LIBS) -o $(TARGET)

clean:
	rm -f $(TARGET) fields.o

=== debian/changelog ===
zfp (1.0.1-4deepin1) unstable; urgency=medium

  * revert 64-bit time_t transition patch.

 -- lichenggang <lichenggang@deepin.org>  Fri, 18 Oct 2024 18:12:31 +0800

zfp (1.0.1-4) unstable; urgency=medium

  * Ack NMU.
  * Bump standards version to 4.7.0.

 -- Alex Myczko <tar@debian.org>  Tue, 18 Jun 2024 13:07:28 +0000

zfp (1.0.1-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063310

 -- Steve Langasek <vorlon@debian.org>  Thu, 29 Feb 2024 08:45:44 +0000

zfp (1.0.1-3) unstable; urgency=medium

  * debian/rules:
    - Revert the changes in the BIT_STREAM_WORD_TYPE configuration
      implemneted with the upload of the upstream version 1.0.1 and
      skip the failing tests (Closes: #1060807).
      According to https://github.com/LLNL/zfp/issues/51, test failures
      in ZFP uni tests are gue to limitations of the test suite implementation
      not supporting all possible configurations.
      On the other hand some of the packages that depend on ZFP, like, e.g.,
      h5z-fzp mandatorily require the old configuration.
  * debian/patches:
    - New 0002-Skip-broken-tests.patch (see comments above).
  * Update d/copyright.

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Wed, 17 Jan 2024 08:08:28 +0000

zfp (1.0.1-2) unstable; urgency=medium

  * Upload to unstable.

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Wed, 27 Dec 2023 07:58:26 +0000

zfp (1.0.1-1) experimental; urgency=medium

  * New upstream release.
  * Update d/copyright.
  * debian/patches:
    - Drop 0001-Prevent-LTO-in-libm-dependency-check.patch, applied upstream.
    - New 0001-Do-not-set-RPATH-RUNPATH.patch.
  * Add salsa CI configuration file.
  * debian/rules:
    - Disable tests on non 64bit architectures
      (see https://github.com/LLNL/zfp/issues/51).
  * Update symbol file for amd64.

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Tue, 26 Dec 2023 17:51:14 +0000

zfp (1.0.0-8) unstable; urgency=medium

  * Switch to autopkgtest-pkg-pybuild.

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Sat, 09 Dec 2023 15:47:40 +0000

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Section: science
 Priority: optional
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Gürkan Myczko <tar@debian.org>,
+Uploaders: Alex Myczko <tar@debian.org>,
            Antonio Valentino <antonio.valentino@tiscali.it>
 Rules-Requires-Root: no
-Testsuite: autopkgtest-pkg-python
-Build-Depends:
+Testsuite: autopkgtest-pkg-pybuild
+Build-Depends: dpkg-dev (>= 1.22.5),
  debhelper-compat (= 13),
  cmake,
  cython3,
@@ -18,7 +18,7 @@
  python3-numpy,
  python3-setuptools,
  python3-all
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/science-team/zfp
 Vcs-Git: https://salsa.debian.org/science-team/zfp.git
 Homepage: https://zfp.llnl.gov

=== debian/watch ===
version=4
opts=\
pgpmode=none,\
dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$//,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|c|beta|b|alpha|a)\d*)$/$1~$2/,\
filenamemangle=s/(?:.*?)?(?:rel|v|@PACKAGE@)?[\-\_]?(\d\S+)\.(tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))/@PACKAGE@-$1.$2/ \
https://github.com/LLNL/zfp/tags \
(?:.*?/archive/(?:.*?/)?)?(?:rel|v|@PACKAGE@)?[\-\_]?(\d\S+(?<!post\d))\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
